#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire10one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 10"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire10one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE104XI - COORDINATE SIGNS OF SHOOT2ONE104XI: (X + ,Y + ,Z + ) 
# -------------------------------------------------------------------------------------------------  

global shot2one104xi            # 10   - 90 

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load10one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False  


# -------------------------------------------------------------------------------------------------
# 10
# -------------------------------------------------------------------------------------------------
shot2one104xi = {
                 1:'0x0y19z',
                 2:'0x0y39z',
                 3:'0x0y59z',
                 4:'0x0y89z',
                 5:'0x13y14z',
                 6:'0x13y15z',
                 7:'0x1y39z',
                 8:'0x1y59z',
                 9:'0x2y69z',
                 10:'0x30y25z',
                 11:'0x3y69z',
                 12:'0x4y69z',
                 13:'0x50y32z',
                 14:'0x72y34z',
                 15:'10x18y21z',
                 16:'10x47y34z',
                 17:'10x70y36z',
                 18:'11x16y21z',
                 19:'11x17y21z',
                 20:'12x0y15z',
                 21:'12x16y21z',
                 22:'13x14y22z',
                 23:'13x15y22z',
                 24:'13x46y35z',
                 25:'14x12y22z',
                 26:'14x13y22z',
                 27:'14x69y37z',
                 28:'15x10y23z',
                 29:'15x11y22z',
                 30:'15x45y35z',
                 31:'16x35y30z',
                 32:'17x44y36z',
                 33:'18x34y31z',
                 34:'18x67y38z',
                 35:'1x12y15z',
                 36:'1x30y25z',
                 37:'20x33y31z',
                 38:'21x32y31z',
                 39:'21x66y39z',
                 40:'23x30y32z',
                 41:'24x29y32z',
                 42:'24x64y39z',
                 43:'25x27y32z',
                 44:'26x25y33z',
                 45:'27x24y33z',
                 46:'27x63y40z',
                 47:'28x22y34z',
                 48:'29x20y34z',
                 49:'2x12y15z',
                 50:'2x30y26z',
                 51:'2x5y7z',
                 52:'2x5y8z',
                 53:'31x61y41z',
                 54:'33x59y41z',
                 55:'34x47y37z',
                 56:'35x0y34z',
                 57:'36x45y38z',
                 58:'36x56y42z',
                 59:'38x43y38z',
                 60:'3x11y15z',
                 61:'3x12y15z',
                 62:'3x3y8z',
                 63:'3x49y33z',
                 64:'3x4y8z',
                 65:'3x71y35z',
                 66:'40x40y39z',
                 67:'42x38y40z',
                 68:'44x35y40z',
                 69:'45x33y41z',
                 70:'4x29y26z',
                 71:'4x3y8z',
                 72:'56x0y41z',
                 73:'5x29y26z',
                 74:'6x49y33z',
                 75:'7x28y26z',
                 76:'7x70y36z',
                 77:'8x19y20z',
                 78:'8x27y27z',
                 79:'8x48y34z',
                 80:'9x19y21z',
                 81:'9x27y27z'}

#"
#"/>
if ack2debug is True:
    keys2xyz = shot2one104xi.keys()
    layer2fire = 10
    
    count2xyz = 0
    
    sum2deviation = 0
    max2deviation = 0
    sum2radius = 0
    max2radius = 0
        
    for key2xyz in keys2xyz:
        i2x = str.find(shot2one104xi[key2xyz],"x")
        i2y = str.find(shot2one104xi[key2xyz],"y") 
        i2z = str.find(shot2one104xi[key2xyz],"z")
                        
        x2coordinate = int(shot2one104xi[key2xyz] [0:i2x])
        y2coordinate = int(shot2one104xi[key2xyz] [i2x+1:i2y])
        z2coordinate = int(shot2one104xi[key2xyz] [i2y+1:i2z])    
        count2xyz = count2xyz + 1
        
        radius2coordinate = (x2coordinate**2 + y2coordinate**2 + z2coordinate**2) ** (1/2)
        if radius2coordinate > max2radius:
            max2radius = radius2coordinate
        sum2radius = sum2radius + radius2coordinate

        deviation2distance = (radius2coordinate - layer2fire)**2
        sum2deviation = sum2deviation + deviation2distance
  
        if deviation2distance**(1/2) > max2deviation:
            max2deviation = deviation2distance**(1/2)
    
    deviation2expected = count2xyz - 100
                
    average2radius = sum2radius / count2xyz    

    degree2freedom = count2xyz - 1
    
    std2deviation = (sum2deviation/degree2freedom) **(1/2) 
    
    std2varians = std2deviation**2
     
    
    print('=' *33)                 
    print('STATISTICS')
    print('=' *33)     
    print("LAYER2FIRE: " , layer2fire)
    print("COUNT2XYZ: " , count2xyz)
    print("DEVIATION2EXPECTED: " , deviation2expected)   
    print("MAX2DEVIATION: " , int(max2deviation))
    print("AVERAGE2RADIUS: " , int(average2radius)) 
    print("MAX2RADIUS: " , int(max2radius))   
    print("STD2DEVIATION: " , int(std2deviation))    
    print("STD2VARIANS: " , int(std2varians))    
    print("DEGREE2FREEDOM: " , int(degree2freedom))
              
    print('=' *33)
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire10one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire10one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    ack2debug = True
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi() 
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE10ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE10ONE4XI -  QUEUE10ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE10ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE10ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE10ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE104XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one104xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE10ONE4XI - SUCCEEDED TO PUT SHOT2ONE104XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE104XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE10ONE4XI *** FAILED TO PUT SHOT2ONE104XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE10ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        # 
        
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one104xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one104xi</nack2put4xi>" 
                     
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE10ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one104xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE10ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE10ONE4XI - RETURNING QUEUE OBJECT QUEUE10ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire10one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
